using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.IO;
using System.Windows.Forms;
using System.Diagnostics;
using Indexing.Windows.Media;

namespace MediaDetectorSample {
    public partial class MainForm : Form {
        public MainForm() {
            InitializeComponent();
        }

        FrameGrabber _fgber;

        delegate void Invoker(object o);

        private void VK쐬NToolStripButton_Click(object sender, EventArgs e) {
            Clear();
        }

        private void JOToolStripButton_Click(object sender, EventArgs e) {
            OpenFile();
        }

        private void MainForm_Load(object sender, EventArgs e) {
            toolStripStatusLabel1.ToolTipText = ":擾Jnʒu";
            toolStripStatusLabel2.ToolTipText = "t@C";
            toolStripStatusLabel3.ToolTipText = "fBA̒";
            toolStripStatusLabel4.ToolTipText = "";
            Clear();
        }

        private void MainForm_FormClosed(object sender, FormClosedEventArgs e) {
            Clear();
        }

        String ToString(TimeSpan ts) {
            return String.Format("{0:D2}:{1:D2}:{2:D2}", ts.Hours, ts.Minutes, ts.Seconds);
        }

        void SetStatusText(object arg) {
            if(InvokeRequired) {
                this.BeginInvoke(new Invoker(SetStatusText), new object[] { arg });
            } else {
                string text = (string)arg;
                toolStripStatusLabel1.Text = text;
                toolStripStatusLabel4.Text = ToString(_elapse.Elapsed);
            }
        }

        void SetTrackBarValue(object arg) {
            if(InvokeRequired) {
                this.BeginInvoke(new Invoker(SetTrackBarValue), new object[] { arg });
            } else {
                FrameGrabber sender = ((Tuple<FrameGrabber, int>)arg).Item1;
                if(sender == _fgber) {
                    int value = ((Tuple<FrameGrabber, int>)arg).Item2;
                    trackBar1.Value = value;
                    if(_fgber.IsRunning) {
                        toolStripStatusLabel4.Text = ToString(_elapse.Elapsed);
                    }
                }
            }
        }

        private void button1_Click(object sender, EventArgs e) {
            if(_fgber == null) {
                return;
            }
            // gbNo[̈ʒut[̎擾Jn
            TimeSpan from = TimeSpan.FromSeconds((int)trackBar1.Value);
            TimeSpan to = from + TimeSpan.FromSeconds((int)numericUpDown1.Value);
            _fgber.Detect(from, to);
        }

        private void button2_Click(object sender, EventArgs e) {
            if(_fgber == null) {
                return;
            }
            // ~
            _fgber.Stop();
        }

        private void button3_Click(object sender, EventArgs e) {
            if(_fgber == null) {
                return;
            }
            // ꎞ~
            _fgber.Pause();
        }

        private void button4_Click(object sender, EventArgs e) {
            if(_fgber == null) {
                return;
            }
            // ĊJ
            _fgber.Play();
        }

        private void button5_Click(object sender, EventArgs e) {
            if(_fgber == null) {
                return;
            }
            // ꎞ~(Ot̒~Ȃ)
            _fgber.Suspend();
        }

        private void button6_Click(object sender, EventArgs e) {
            if(_fgber == null) {
                return;
            }
            // ĊJ(SuspendԂ̍ĊJ)
            _fgber.Resume();
        }

        void Clear() {
            if(_fgber != null) {
                _fgber.Stop();
                _fgber.GrabStarted -= _fgber_GrabStarted;
                _fgber.GrabCompleted -= _fgber_GrabCompleted;
                _fgber.GrabProgressing -= _fgber_GrabProgressing;
                _fgber.Dispose();
                _fgber = null;
            }
            trackBar1.Maximum = 0;
            pictureBox1.Image = null;
            toolStripStatusLabel1.Text = ""; // :擾Jnʒu
            toolStripStatusLabel2.Text = ""; // t@C
            toolStripStatusLabel2.Image = null;
            toolStripStatusLabel3.Text = ""; // fBA̒
            toolStripStatusLabel4.Text = ""; // 
            label1.Text = "N/A"; // AXyNgTCY
        }

        void OpenFile() {
            using(OpenFileDialog dlg = new OpenFileDialog()) {
                dlg.Filter = string.Format("fBA t@C({0})|{0}|ׂẴt@C|*.*", "*.wmv;*.wmx;*.mpg;*.mpeg;*.mov;*.avi;*.asf;*.flv;*.mkv;*.ogm;*.rm;*.rmvb;*.mp4;*.ts");
                if(dlg.ShowDialog() == DialogResult.OK) {
                    try {
                        Cursor = Cursors.WaitCursor;
                        Clear();

                        try {
                            // t[Oo
                            _fgber = new FrameGrabber(dlg.FileName, checkBox1.Checked, checkBox2.Checked);
                        } catch(VideoNotRenderedException ex) {
                            MessageBox.Show(ex.FileName, "fBAFł܂ł", MessageBoxButtons.OK, MessageBoxIcon.Error);
                            return;
                        }

                        // Cxgnhw肷
                        _fgber.GrabStarted += _fgber_GrabStarted;
                        _fgber.GrabCompleted += _fgber_GrabCompleted;
                        _fgber.GrabProgressing += _fgber_GrabProgressing;

                        toolStripStatusLabel1.Text = "ready";
                        toolStripStatusLabel2.Text = Path.GetFileNameWithoutExtension(_fgber.FileName);
                        toolStripStatusLabel2.Image = GetIconBitmap(_fgber.FileName);
                        TimeSpan len = _fgber.StreamLength;
                        toolStripStatusLabel3.Text = ToString(len);

                        // fBA̒gbNo[ɕ\
                        trackBar1.Maximum = (int)_fgber.StreamLength.TotalSeconds;

                        // AXyNgTCY\
                        Size arv = _fgber.NativeARVideoSize;
                        if(arv.Height == 0 && arv.Width == 0) {
                            label1.Text = "N/A";
                        } else {
                            label1.Text = string.Format("{0}x{1}", arv.Width, arv.Height);
                        }

                        // 擪t[\
                        Bitmap frame = _fgber.GetFrame(TimeSpan.Zero);
                        ShowFrame(frame, TimeSpan.Zero, TimeSpan.Zero);
                    } finally {
                        Cursor = Cursors.Default;
                    }
                }
            }
        }

        Bitmap GetIconBitmap(string file) {
            try {
                return Icon.ExtractAssociatedIcon(file).ToBitmap();
            } catch {
                return null;
            }
        }

        /// <summary>
        /// Jnʒu
        /// </summary>
        TimeSpan _start;

        /// <summary>
        /// 
        /// </summary>
        Stopwatch _elapse = new Stopwatch();

        void DrawTime(Bitmap bitmap, TimeSpan current, TimeSpan tc) {
            using(Graphics gr = Graphics.FromImage(bitmap)) {
                gr.DrawString(current.ToString(), this.Font, Brushes.Orange, 0, 0);
                if(tc.Ticks > 0) {
                    gr.DrawString(tc.ToString(), this.Font, Brushes.Orange, 0, bitmap.Height - Font.Height);
                }
            }
        }

        void ShowFrame(Bitmap bmp, TimeSpan pos, TimeSpan tc) {
            if(bmp == null) {
                pictureBox1.Image = null;
            } else {
                Size thumbSize = pictureBox1.Size;
                double ar; // AXyNg
                if(_fgber.NativeARVideoSize.Height != 0) {
                    // lCeBuAXyNgTCYg
                    ar = (double)_fgber.NativeARVideoSize.Width / _fgber.NativeARVideoSize.Height;
                } else {
                    ar = (double)bmp.Width / bmp.Height;
                }
                // AXyNgɏ]ăTCY𒲐
                if(ar > 1) {
                    thumbSize.Height = (int)(thumbSize.Width / ar);
                } else if(ar < 1) {
                    thumbSize.Width = (int)(thumbSize.Width * ar);
                }
                Bitmap thumb = new Bitmap(bmp, thumbSize);
                DrawTime(thumb, pos, tc);
                pictureBox1.Image = thumb;
            }
        }

        /// <summary>
        /// JnCxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="args"></param>
        void _fgber_GrabStarted(FrameGrabber sender, FrameGrabber.GrabStartedEventArgs args) {
            SetStatusText("擾:" + args.Time.ToString());
            _start = args.Time;
            _elapse.Restart();
        }

        /// <summary>
        /// ICxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="args"></param>
        void _fgber_GrabCompleted(FrameGrabber sender, FrameGrabber.GrabCompletedEventArgs args) {
            SetStatusText("擾:");
            _elapse.Stop();
        }

        /// <summary>
        /// t[擾Cxgnh
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="args"></param>
        void _fgber_GrabProgressing(FrameGrabber sender, FrameGrabber.GrabProgressingEventArgs args) {
            TimeSpan current = _start + args.Time;
            ShowFrame(args.Bitmap, current, args.Time);
            int sec = (int)(current.TotalSeconds);
            SetTrackBarValue(new Tuple<FrameGrabber, int>(sender, sec));
        }

        private void trackBar1_ValueChanged(object sender, EventArgs e) {
            if(_fgber != null) {
                if( !_fgber.IsRunning ) {
                    // t[擾ĕ\
                    TimeSpan pos = TimeSpan.FromSeconds(trackBar1.Value);
                    Bitmap bmp = _fgber.GetFrame(pos);
                    ShowFrame(bmp, pos, TimeSpan.Zero);
                }
            }
        }
    }
}